package com.halomobi.view.imageloader.cache;


import com.halomobi.utils.KeyUtil;

/**
 * @author Jeve
 * @ClassName: MemoryCache
 * @Description: 内存缓存策略
 * @date 2016-3-3 下午9:49:00
 */
public class MemoryCache implements ImageCache {

    private LruCache<String, byte[]> memoryCache;


    public MemoryCache() {
        int cacheSize = (int) Runtime.getRuntime().maxMemory() / 8;
        memoryCache = new LruCache<String, byte[]>(cacheSize) {
            @Override
            protected int sizeOf(String key, byte[] value) {
                return value.length;
            }
        };
    }

    @Override
    public byte[] getCache(String url) {
        return memoryCache.get(getCacheKey(url));
    }

    @Override
    public void putCache(String url, byte[] value) {
        memoryCache.put(getCacheKey(url), value);
    }

    private String getCacheKey(String url) {
        return KeyUtil.getMD5(url);
    }

    @Override
    public void clear() {
        memoryCache.evictAll();
    }

}
